diff --git a/pki/base/common/src/com/netscape/cms/profile/input/SubjectDNInput.java b/pki/base/common/src/com/netscape/cms/profile/input/SubjectDNInput.java
index 8691b45c739dce570b0cc98c2b6122ff4f1a0cf6..4a8f6050568b558e28ff2af343636f349f31a620 100644
--- a/pki/base/common/src/com/netscape/cms/profile/input/SubjectDNInput.java
+++ b/pki/base/common/src/com/netscape/cms/profile/input/SubjectDNInput.java
@@ -81,8 +81,8 @@ public class SubjectDNInput extends EnrollInput implements IProfileInput {
     /**
      * Returns selected value names based on the configuration.
      */
-    public Enumeration getValueNames() {
-         Vector v = new Vector();
+    public Enumeration<String> getValueNames() {
+         Vector<String> v = new Vector<String>();
          v.addElement(VAL_SUBJECT);
          return v.elements();
     }
diff --git a/pki/base/common/src/com/netscape/cms/profile/output/EnrollOutput.java b/pki/base/common/src/com/netscape/cms/profile/output/EnrollOutput.java
index 3013e881017c0a352032a61e3833ad8e1b7c7764..5e3f077b2654cffc1d09b0d2fca0259ad74bfee3 100644
--- a/pki/base/common/src/com/netscape/cms/profile/output/EnrollOutput.java
+++ b/pki/base/common/src/com/netscape/cms/profile/output/EnrollOutput.java
@@ -39,8 +39,8 @@ import com.netscape.certsrv.request.IRequest;
  */
 public abstract class EnrollOutput implements IProfileOutput { 
     private IConfigStore mConfig = null;
-    private Vector mValueNames = new Vector();
-    protected Vector mConfigNames = new Vector();
+    private Vector<String> mValueNames = new Vector<String>();
+    protected Vector<String> mConfigNames = new Vector<String>();
  
     /**
      * Initializes this default policy.
@@ -98,7 +98,7 @@ public abstract class EnrollOutput implements IProfileOutput {
     /**
      * Retrieves a list of names of the value parameter.
      */
-    public Enumeration getValueNames() {
+    public Enumeration<String> getValueNames() {
         return mValueNames.elements();
     }
 
@@ -115,7 +115,7 @@ public abstract class EnrollOutput implements IProfileOutput {
         request.setExtData(name, value);
     }
 
-    public Enumeration getConfigNames() {
+    public Enumeration<String> getConfigNames() {
         return mConfigNames.elements();
     }
 
diff --git a/pki/base/common/src/com/netscape/cms/servlet/admin/ProfileAdminServlet.java b/pki/base/common/src/com/netscape/cms/servlet/admin/ProfileAdminServlet.java
index 6f64d81a09b89f36ec0723db7cfc2f990b950789..9c83a30c84f051613a5cb6450e63b203bf26acb9 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/admin/ProfileAdminServlet.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/admin/ProfileAdminServlet.java
@@ -51,6 +51,7 @@ import com.netscape.certsrv.property.EPropertyException;
 import com.netscape.certsrv.property.IDescriptor;
 import com.netscape.certsrv.registry.IPluginInfo;
 import com.netscape.certsrv.registry.IPluginRegistry;
+import com.netscape.cms.profile.common.ProfilePolicy;
 
 
 /**
@@ -383,7 +384,7 @@ public class ProfileAdminServlet extends AdminServlet {
         HttpServletResponse resp)
         throws ServletException, IOException {
 
-        Enumeration impls = mRegistry.getIds("profile");
+        Enumeration<String> impls = mRegistry.getIds("profile");
         NameValuePairs nvp = new NameValuePairs();
 
         while (impls.hasMoreElements()) {
@@ -592,11 +593,12 @@ public class ProfileAdminServlet extends AdminServlet {
             }
 
             IProfileInput input = null;
-            Enumeration names = req.getParameterNames();
+            @SuppressWarnings("unchecked")
+			Enumeration<String> names = req.getParameterNames();
             NameValuePairs nvps = new NameValuePairs();
 
             while (names.hasMoreElements()) {
-                String name = (String) names.nextElement();
+                String name =  names.nextElement();
 
                 if (name.equals("OP_SCOPE"))
                     continue;
@@ -718,11 +720,12 @@ public class ProfileAdminServlet extends AdminServlet {
             }
 
             IProfileOutput output = null;
-            Enumeration names = req.getParameterNames();
+            @SuppressWarnings("unchecked")
+			Enumeration<String> names = req.getParameterNames();
             NameValuePairs nvps = new NameValuePairs();
 
             while (names.hasMoreElements()) {
-                String name = (String) names.nextElement();
+                String name =  names.nextElement();
 
                 if (name.equals("OP_SCOPE"))
                     continue;
@@ -819,10 +822,11 @@ public class ProfileAdminServlet extends AdminServlet {
         try {
             String profileId = "";
             String policyId = "";
-            Enumeration names = req.getParameterNames();
+            @SuppressWarnings("unchecked")
+			Enumeration<String> names = req.getParameterNames();
 
             while (names.hasMoreElements()) {
-                String name = (String) names.nextElement();
+                String name =  names.nextElement();
 
                 if (name.equals("OP_SCOPE"))
                     continue;
@@ -939,10 +943,11 @@ public class ProfileAdminServlet extends AdminServlet {
         try {
             String profileId = "";
             String inputId = "";
-            Enumeration names = req.getParameterNames();
+            @SuppressWarnings("unchecked")
+			Enumeration<String> names = req.getParameterNames();
 
             while (names.hasMoreElements()) {
-                String name = (String) names.nextElement();
+                String name = names.nextElement();
 
                 if (name.equals("OP_SCOPE"))
                     continue;
@@ -1056,7 +1061,8 @@ public class ProfileAdminServlet extends AdminServlet {
         try {
             String profileId = "";
             String outputId = "";
-            Enumeration names = req.getParameterNames();
+            @SuppressWarnings("unchecked")
+			Enumeration<String> names = req.getParameterNames();
 
             while (names.hasMoreElements()) {
                 String name = (String) names.nextElement();
@@ -1205,7 +1211,8 @@ public class ProfileAdminServlet extends AdminServlet {
             IPolicyDefault def = policy.getDefault();
             IConfigStore defConfig = def.getConfigStore();
         
-            Enumeration names = req.getParameterNames();
+            @SuppressWarnings("unchecked")
+			Enumeration<String> names = req.getParameterNames();
 
             while (names.hasMoreElements()) {
                 String name = (String) names.nextElement();
@@ -1341,10 +1348,11 @@ public class ProfileAdminServlet extends AdminServlet {
             IPolicyConstraint con = policy.getConstraint();
             IConfigStore conConfig = con.getConfigStore();
 
-            Enumeration names = req.getParameterNames();
+            @SuppressWarnings("unchecked")
+			Enumeration<String> names = req.getParameterNames();
 
             while (names.hasMoreElements()) {
-                String name = (String) names.nextElement();
+                String name =  names.nextElement();
 
                 if (name.equals("OP_SCOPE"))
                     continue;
@@ -1478,7 +1486,8 @@ public class ProfileAdminServlet extends AdminServlet {
             IPolicyDefault def = policy.getDefault();
             IConfigStore defConfig = def.getConfigStore();
         
-            Enumeration names = req.getParameterNames();
+            @SuppressWarnings("unchecked")
+			Enumeration<String> names = req.getParameterNames();
 
             while (names.hasMoreElements()) {
                 String name = (String) names.nextElement();
@@ -1606,7 +1615,8 @@ public class ProfileAdminServlet extends AdminServlet {
             IProfileInput input = profile.getProfileInput(inputId);
             IConfigStore inputConfig = input.getConfigStore();
 
-            Enumeration names = req.getParameterNames();
+            @SuppressWarnings("unchecked")
+			Enumeration<String> names = req.getParameterNames();
 
             while (names.hasMoreElements()) {
                 String name = (String) names.nextElement();
@@ -1725,7 +1735,8 @@ public class ProfileAdminServlet extends AdminServlet {
             IProfileOutput output = profile.getProfileOutput(outputId);
             IConfigStore outputConfig = output.getConfigStore();
 
-            Enumeration names = req.getParameterNames();
+            @SuppressWarnings("unchecked")
+			Enumeration<String> names = req.getParameterNames();
 
             while (names.hasMoreElements()) {
                 String name = (String) names.nextElement();
@@ -1849,7 +1860,8 @@ public class ProfileAdminServlet extends AdminServlet {
             IPolicyConstraint con = policy.getConstraint();
             IConfigStore conConfig = con.getConfigStore();
 
-            Enumeration names = req.getParameterNames();
+            @SuppressWarnings("unchecked")
+			Enumeration<String> names = req.getParameterNames();
 
             CMS.debug("ProfileAdminServlet: modifyPolicyConstraintConfig policy " + policy + " con " + con); 
             while (names.hasMoreElements()) {
@@ -1959,10 +1971,10 @@ public class ProfileAdminServlet extends AdminServlet {
         rule = policy.getDefault();
 
         NameValuePairs nvp = new NameValuePairs();
-        Enumeration names = rule.getConfigNames();
+        Enumeration<String> names = rule.getConfigNames();
 
         while (names.hasMoreElements()) {
-            String name = (String) names.nextElement();
+            String name = names.nextElement();
             IDescriptor desc = rule.getConfigDescriptor(getLocale(req), name);
 
             if (desc == null) {
@@ -2007,10 +2019,10 @@ public class ProfileAdminServlet extends AdminServlet {
         IPolicyConstraint rule = policy.getConstraint();
 
         NameValuePairs nvp = new NameValuePairs();
-        Enumeration names = rule.getConfigNames();
+        Enumeration<String> names = rule.getConfigNames();
 
         while (names.hasMoreElements()) {
-            String name = (String) names.nextElement();
+            String name = names.nextElement();
             IDescriptor desc = rule.getConfigDescriptor(getLocale(req), name);
 
             if (desc == null) {
@@ -2040,7 +2052,7 @@ public class ProfileAdminServlet extends AdminServlet {
         }
 
         NameValuePairs nvp = new NameValuePairs();
-        Enumeration setIds = profile.getProfilePolicySetIds();
+        Enumeration<String> setIds = profile.getProfilePolicySetIds();
 
         if (!setIds.hasMoreElements()) {
             // no set id; this is a brand new profile
@@ -2049,7 +2061,7 @@ public class ProfileAdminServlet extends AdminServlet {
         }
         while (setIds.hasMoreElements()) {
             String setId = (String) setIds.nextElement();
-            Enumeration policies = profile.getProfilePolicies(setId);
+            Enumeration<ProfilePolicy> policies = profile.getProfilePolicies(setId);
 
             while (policies.hasMoreElements()) {
                 IProfilePolicy policy = (IProfilePolicy) policies.nextElement();
@@ -2082,7 +2094,7 @@ public class ProfileAdminServlet extends AdminServlet {
         }
 
         NameValuePairs nvp = new NameValuePairs();
-        Enumeration outputs = profile.getProfileOutputIds();
+        Enumeration<String> outputs = profile.getProfileOutputIds();
 
         while (outputs.hasMoreElements()) {
             String outputId = (String) outputs.nextElement();
@@ -2109,7 +2121,7 @@ public class ProfileAdminServlet extends AdminServlet {
         }
 
         NameValuePairs nvp = new NameValuePairs();
-        Enumeration inputs = profile.getProfileInputIds();
+        Enumeration<String> inputs = profile.getProfileInputIds();
 
         while (inputs.hasMoreElements()) {
             String inputId = (String) inputs.nextElement();
@@ -2143,10 +2155,10 @@ public class ProfileAdminServlet extends AdminServlet {
         NameValuePairs nvp = new NameValuePairs();
 
         profileInput = profile.getProfileInput(inputId);
-        Enumeration names = profileInput.getConfigNames();
+        Enumeration<String> names = profileInput.getConfigNames();
 
         while (names.hasMoreElements()) {
-            String name = (String) names.nextElement();
+            String name = names.nextElement();
             IDescriptor desc = profileInput.getConfigDescriptor(
 		getLocale(req), name);
             if (desc == null) {
@@ -2184,10 +2196,10 @@ public class ProfileAdminServlet extends AdminServlet {
         NameValuePairs nvp = new NameValuePairs();
 
         profileOutput = profile.getProfileOutput(outputId);
-        Enumeration names = profileOutput.getConfigNames();
+        Enumeration<String> names = profileOutput.getConfigNames();
 
         while (names.hasMoreElements()) {
-            String name = (String) names.nextElement();
+            String name = names.nextElement();
             IDescriptor desc = profileOutput.getConfigDescriptor(
 		getLocale(req), name);
             if (desc == null) {
@@ -2208,10 +2220,10 @@ public class ProfileAdminServlet extends AdminServlet {
         throws ServletException, IOException {
 
         NameValuePairs nvp = new NameValuePairs();
-        Enumeration e = mProfileSub.getProfileIds();
+        Enumeration<String> e = mProfileSub.getProfileIds();
 
         while (e.hasMoreElements()) {
-            String profileId = (String) e.nextElement();
+            String profileId =  e.nextElement();
             IProfile profile = null;
 
             try {
diff --git a/pki/base/common/src/com/netscape/cms/servlet/admin/RegistryAdminServlet.java b/pki/base/common/src/com/netscape/cms/servlet/admin/RegistryAdminServlet.java
index be9eb456e80dad9481d713f31c111455f12d6f9c..2ddc230658e76655b95e85c1ee881efec42aea1e 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/admin/RegistryAdminServlet.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/admin/RegistryAdminServlet.java
@@ -245,11 +245,11 @@ public class RegistryAdminServlet extends AdminServlet {
         throws ServletException, IOException {
 
         String scope = req.getParameter(Constants.OP_SCOPE);
-        Enumeration impls = mRegistry.getIds(scope);
+        Enumeration<String> impls = mRegistry.getIds(scope);
         NameValuePairs nvp = new NameValuePairs();
 
         while (impls.hasMoreElements()) {
-            String id = (String) impls.nextElement();
+            String id =  impls.nextElement();
             IPluginInfo info = mRegistry.getPluginInfo(scope, id);
 
             nvp.add(id, info.getClassName() + "," + 
@@ -276,7 +276,7 @@ public class RegistryAdminServlet extends AdminServlet {
                 Class.forName(className).newInstance();
 
             if (policyDefaultClass != null) {
-                Enumeration impls = mRegistry.getIds("constraintPolicy");
+                Enumeration<String> impls = mRegistry.getIds("constraintPolicy");
 
                 while (impls.hasMoreElements()) {
                     String constraintID = (String) impls.nextElement();
@@ -332,11 +332,11 @@ public class RegistryAdminServlet extends AdminServlet {
         } catch (Exception e) {
         }
         if (template != null) {
-            Enumeration names = template.getConfigNames();
+            Enumeration<String> names = template.getConfigNames();
 
             if (names != null) {
                 while (names.hasMoreElements()) {
-                    String name = (String) names.nextElement(); 
+                    String name = names.nextElement(); 
                         CMS.debug("RegistryAdminServlet: getProfileImpl descriptor " + name);
                     IDescriptor desc = template.getConfigDescriptor(getLocale(req), name);
 
diff --git a/pki/base/common/src/com/netscape/cms/servlet/base/CMSServlet.java b/pki/base/common/src/com/netscape/cms/servlet/base/CMSServlet.java
index 1c5062758662f2e4593c802237c87b3658089a0e..60075b6d50196020d8d1e3d3a28c8234e4b62fff 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/base/CMSServlet.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/base/CMSServlet.java
@@ -1042,7 +1042,7 @@ public abstract class CMSServlet extends HttpServlet {
      */
     protected void saveHttpParams(
         IArgBlock httpParams, IRequest req) {
-        Hashtable<String, Object> saveParams = new Hashtable<String, Object>();
+        Hashtable<String, String> saveParams = new Hashtable<String, String>();
 
         Enumeration<String> names = httpParams.elements();
 
@@ -1065,7 +1065,7 @@ public abstract class CMSServlet extends HttpServlet {
                 // retrieves string values.
                 // TODO - when we can use JDK5 features we should typecast
                 // the params until they get here
-                saveParams.put(name, httpParams.get(name));
+                saveParams.put(name, (String) httpParams.get(name));
             }
         }
         req.setExtData(IRequest.HTTP_PARAMS, saveParams);
@@ -1477,7 +1477,7 @@ public abstract class CMSServlet extends HttpServlet {
 
         // # 56230 - expose auth token parameters to the policy predicate
         if (token != null && req != null) {
-            Enumeration e = token.getElements();
+            Enumeration<String> e = token.getElements();
             while (e.hasMoreElements()) {
                 String n = (String) e.nextElement();
                 String[] x1 = token.getInStringArray(n);
@@ -2197,7 +2197,7 @@ public abstract class CMSServlet extends HttpServlet {
             return ILogger.SIGNED_AUDIT_EMPTY_VALUE;
         }
 
-        Enumeration groups = null;
+        Enumeration<IGroup> groups = null;
 
         try {
             groups = mUG.findGroups("*");
diff --git a/pki/base/common/src/com/netscape/cms/servlet/profile/ProfileProcessServlet.java b/pki/base/common/src/com/netscape/cms/servlet/profile/ProfileProcessServlet.java
index a159c0f2dfa5985587d5467564b039da7623ec28..3261535a673d3eeb06c7cb053ae3449fd0fcf58b 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/profile/ProfileProcessServlet.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/profile/ProfileProcessServlet.java
@@ -703,12 +703,12 @@ public class ProfileProcessServlet extends ProfileServlet {
                     IProfileOutput profileOutput = profile.getProfileOutput(
                             outputId);
 
-                    Enumeration outputNames = profileOutput.getValueNames();
+                    Enumeration<String> outputNames = profileOutput.getValueNames();
 
                     if (outputNames != null) {
                         while (outputNames.hasMoreElements()) {
                             ArgSet outputset = new ArgSet();
-                            String outputName = (String)
+                            String outputName = 
                                 outputNames.nextElement();
                             IDescriptor outputDesc =
                                 profileOutput.getValueDescriptor(locale,
diff --git a/pki/base/common/src/com/netscape/cmscore/notification/EmailFormProcessor.java b/pki/base/common/src/com/netscape/cmscore/notification/EmailFormProcessor.java
index aa1fd15f2ce94f0edcce600c65fdef0cbee022e0..770b5ba421044a31f5cfc978b821bb42e34a6927 100644
--- a/pki/base/common/src/com/netscape/cmscore/notification/EmailFormProcessor.java
+++ b/pki/base/common/src/com/netscape/cmscore/notification/EmailFormProcessor.java
@@ -71,8 +71,8 @@ public class EmailFormProcessor implements IEmailFormProcessor {
         };
 
     // stores the eventual content of the email
-    Vector mContent = new Vector();
-    Hashtable mTok2vals = null;
+    Vector<String> mContent = new Vector<String>();
+    Hashtable<String, Object> mTok2vals = null;
 
     public EmailFormProcessor() {
     }
@@ -87,7 +87,7 @@ public class EmailFormProcessor implements IEmailFormProcessor {
      * @return mail content
      */
     public String getEmailContent(String form,
-        Hashtable tok2vals) {
+        Hashtable<String, Object> tok2vals) {
         mTok2vals = tok2vals;
 
         if (form == null) {
@@ -154,7 +154,7 @@ public class EmailFormProcessor implements IEmailFormProcessor {
             boolean matched = false;
             String tok = null;
 
-            for (Enumeration e = mTok2vals.keys(); e.hasMoreElements();) {
+            for (Enumeration<String> e = mTok2vals.keys(); e.hasMoreElements();) {
                 // get key
                 tok = (String) e.nextElement();
 
@@ -167,7 +167,7 @@ public class EmailFormProcessor implements IEmailFormProcessor {
                         String s = (String) o;
 
                         if (!s.equals("")) {
-                            mContent.add(o);
+                            mContent.add(s);
                         } else {
                             break;
                         }
@@ -221,18 +221,18 @@ public class EmailFormProcessor implements IEmailFormProcessor {
     /**
      * takes a vector of strings and concatenate them
      */
-    public String formContent(Vector vec) {
+    public String formContent(Vector<String> vec) {
         String content = null;
 
-        Enumeration e = vec.elements();
+        Enumeration<String> e = vec.elements();
 
         // initialize content with first element
         if (e.hasMoreElements()) {
-            content = (String) e.nextElement();
+            content =  e.nextElement();
         }
 
         while (e.hasMoreElements()) {
-            String v = (String) e.nextElement();
+            String v = e.nextElement();
 
             content += v;
         }
